import Test.Tasty ( TestTree, defaultMain, localOption, testGroup )
import Test.Tasty.QuickCheck ( QuickCheckTests(..), QuickCheckMaxRatio(..) )
import Cidr ( cidr_properties, cidr_tests )
import IPv4Address ( ipv4address_properties, ipv4address_tests )
import Octet ( octet_properties, octet_tests )

tests :: TestTree
tests = testGroup "All Tests" [
          cidr_properties,
          cidr_tests,
          ipv4address_properties,
          ipv4address_tests,
          octet_properties,
          octet_tests ]

main :: IO ()
main =
  defaultMain $
    localOption (QuickCheckTests 5000) $
    localOption (QuickCheckMaxRatio 50) tests
